/**
 * Created by hzlichaolin on 2016/7/13.
 * you can delete more than one object through this object
 */
var httpRequest = require('./httpRequest')
var inherits = require('./inherits')
var authrization = require('../services/authorization')
var xml2js = require('xml2js')
var crypto = require('crypto')

function deleteMultipleObjectsRequest() {
    httpRequest.call(this)

    this.options = {host: null, port: -1, path: null, method: 'POST', headers:{}
    };

    this.bucketName = null
    this.isQuiet = null
    this.objectArray = null

    this.createRequestBody = function () {
        var json = {
            Quiet:this.isQuiet,
            Object:this.objectArray
        }

        var b = new xml2js.Builder()
        var xml = b.buildObject(json)
        xml = xml.replace('<root>','<Delete>').replace('</root>','</Delete>')
        // console.log(xml)
        return xml
    }
}

inherits(deleteMultipleObjectsRequest,httpRequest)

deleteMultipleObjectsRequest.prototype.setBucketName = function (bucketName) {
    this.bucketName = bucketName
}

deleteMultipleObjectsRequest.prototype.setQuiet = function (quiet) {
    this.isQuiet = quiet
}

deleteMultipleObjectsRequest.prototype.setObjectArray = function (objectArray) {
    this.objectArray = objectArray
}

deleteMultipleObjectsRequest.prototype.sendRequest = function (func) {
    this.options.path = '/' + this.bucketName + '/?delete'
    this.options.headers['Date'] = (new Date()).toUTCString();
    this.options.body = new Buffer(this.createRequestBody().toString())
    this.options.headers['Content-Length'] = this.options.body.length
    this.options.headers['Content-MD5'] = crypto.createHash('md5').update(this.options.body).digest('hex')
    var authStr = authrization(this.accessId,this.secretKey,this.options.method,this.options.headers,this.options.path)
    this.options.headers['Authorization'] = authStr
    httpRequest.prototype.sendRequest(this.options,func);
}



module.exports = deleteMultipleObjectsRequest;
