/**
 * Created by hzlichaolin on 2016/7/12.
 */
var http = require('http');
var util = require('util')

function httpRequest() {
    this.accessId = null
    this.secretKey = null
    this.contentMD5 = null
    this.contentType = null
    this.contentLength = null
    this.resource = null
}

httpRequest.prototype.setMethod = function (method) {
    this.options.method = method;
}

httpRequest.prototype.setHost = function (host) {
    this.options.host = host;
}

httpRequest.prototype.setPort = function (port) {
    this.options.port = port;
}

httpRequest.prototype.setAccessId = function (accessId) {
    this.accessId = accessId
}

httpRequest.prototype.setSecretKey = function (secretKey) {
    this.secretKey = secretKey
}

httpRequest.prototype.setContentMD5 = function (contentMD5) {
    this.contentMD5 = contentMD5
}

httpRequest.prototype.setContentType = function (contentType) {
    this.contentType = contentType
}

httpRequest.prototype.setContentLength = function (contentLength) {
    this.contentLength = contentLength
}

httpRequest.prototype.setResource = function (resource) {
    this.resource = resource
}

httpRequest.prototype.sendRequest = function (options,func) {
    var req = http.request(options, func);

    req.on('error', function(err){
        func(options, err)
    });
    if (options.body != null){
        req.write(options.body)
    }
    req.end();
}

module.exports = httpRequest;