/**
 * Created by hzlichaolin on 2016/7/20.
 */

var NOSClient = require('../index')
var expect = require('chai').expect;
var client = new NOSClient()
client.setAccessId('accessId')
client.setSecretKey('secretKey')
client.setHost('localhost')
client.setPort('8500')

describe('delete_multiple_objects test', function() {

    var statusCode = null

    var func = function (res) {
        //only for get_object test, so it's ok to be empty here
    }

    beforeEach(function(done) {

        client.put_object({bucket:'bucket',key:'a.txt',body:new Buffer('呦西')},func)
        client.put_object({bucket:'bucket',key:'b.txt',body:new Buffer('呦西')},func)
        client.put_object({bucket:'bucket',key:'c.txt',body:new Buffer('呦西')},func)
        client.put_object({bucket:'bucket',key:'d.txt',body:new Buffer('呦西')},func)

        setTimeout(function() {
            done()
        }, 1000);
    });

    it('it should be 200', function(done) {

        client.delete_objects({bucket:'bucket',keys:[{Key:'b.txt'},{Key:'c.txt'},{Key:'a.txt'},{Key:'d.txt'}],quiet:'False'},function (res) {
            statusCode = res.statusCode
        })

        setTimeout(function() {
            expect(statusCode).to.be.equal(200);
            done()
        }, 1000);
    });

});
